/*
 * $Header: /u0/casey/src/mcast/libmcast/RCS/mc_write.c,v 1.2 93/01/16 19:53:33 casey Exp $
 */

/*
 * Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Lawrence Livermore National Laboratory and its
 *	contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static char rcsid[] = "$Header: /u0/casey/src/mcast/libmcast/RCS/mc_write.c,v 1.2 93/01/16 19:53:33 casey Exp $";
static char copyright[] =
    "Copyright (c) 1992 The Regents of the University of California.\n"
    "All rights reserved.\n";
static char classification[] =
    "Unclassified\n";
#endif


/*
 * MCAST SYSLIB PUBLIC: mc_write: write(2) system call emulation routine.
 */


#include "mc_lib.h"


int
mc_write(int s, const void *buf, size_t len)
{
	mc_state *sp = &_mc_state[s];

	if (s < 0 || s >= MC_MAX_CONNECTIONS
	    || !(sp->state & MC_VALID)) {
		/* return(write(s, buf, len)); */
		errno = EBADF;
		return(-1);
	}
	if (sp->state & MC_CORRUPTED) {
		errno = EIO;
		return(-1);
	}
	if ((int)len <= 0) {
		errno = EINVAL;
		return(-1);
	}
	if (!(sp->state & MC_BOUND)) {
		errno = EPIPE;
		return(-1);
	}
	if (sp->state & MC_SHUTDOWNSEND) {
		errno = EPIPE;
		return(-1);
	}
	return(_mc_write(s, buf, len, 0, NULL));
}
